#include <PocketFrog.h>

using namespace Frog;


class SnooblesGame : public Game
{
public:

    // Construction
    SnooblesGame(HINSTANCE hInstance);

    // Framework callbacks
    virtual bool GameInit();
    virtual void GameEnd();
    virtual void GameResume();
    virtual void GameLoop();
    virtual void StylusDown( Point stylus );
    virtual void StylusUp( Point stylus );
    virtual void StylusMove( Point stylus );
    virtual void ButtonDown( int button );
    virtual void ButtonUp( int button );

    void Scroller(DisplayDevice *display);
    void MainShip(DisplayDevice *display);
    void InitFire(int X, int Y);
    void DrawFire(DisplayDevice *display);
    void InitCloud(int X, int Y);
    void DrawCloud(DisplayDevice *display);
    void InitDfly(int X, int Y);
    void DrawDfly(DisplayDevice *display);
    void InitExp(int X, int Y);
    void DrawExp(DisplayDevice *display);
    void DoCollision();

private:

    // Data
    Surface* m_font;
    Surface* m_images[4];       // Moving images
    Surface* m_background;      // Background image
    Surface* m_mainship;        // main spaceship.
    Surface* m_dragonfly;       // dragon fly mechs.
    Surface* m_numbers;         // Numbers to display FPS
    Rect     m_position[4];     // Positions of images
    int      m_dragImage;       // # of image being dragged (-1 if none)
    Point    m_dragOffset;      // Offset of stylus to image being dragged

    int      m_FPSCounter;      // FPS counter
    uint32_t m_FPSTicks[16];    // Ticks for last 16 frames

    int SX;
    int SY;
    int sframe;

    BOOL b_up;
    BOOL b_down;
    BOOL b_left;
    BOOL b_right;
    BOOL b_fire;


    HINSTANCE Instance;

};

