/*
  Snoobles ? Silly name for a shooter but it's just my attempt
  to do something with pocketfrog and test the performance.
  Look at the TestFont variable/class to see how to use the
  font classes from font.h and font.cpp

  Jason Chong  jcvw75@yahoo.com
*/



#include <stdio.h>
#include <hss.h>
#include "snoobles.h"
#include "resource.h"
#include "font.h"

#pragma comment(lib, "hss.lib")
#define MAXLASER 100
#define MAXCLOUD 50
#define MAXDFLY 25
#define MAXEXPLODE 25

using namespace Frog;

CComModule _Module;

typedef struct _LASER {
    BOOL Active;
    int X;
    int Y;
}LASER;

typedef struct _CLOUD {
    BOOL Active;
    int X;
    int Y;
    int Alpha;
    int Step;
}CLOUD;

typedef struct _DFLY {
    BOOL Active;
    int X;
    int Y;
    int Frame;
    int Step;
}DFLY;

typedef struct _EXPLODE {
    BOOL Active;
    int X;
    int Y;
    int Alpha;
    int Frame;
}EXPLODE;




typedef struct _HSSCONFIG {
    DWORD        dwSoundFrequency;

    DWORD        dwSoundBPS;

    BOOL         bSoundStereo;
    DWORD        dwMODChannels;
    DWORD        dwSFXChannels;
} HSSCONFIG;


    Module  *m_module;   // our protraker mod obj
    SoundFX *m_laser;
    SoundFX *m_explode;
    Sound m_sound;
    HSSCONFIG hssconfig;
    LASER Laser[MAXLASER];
    CLOUD Cloud[MAXCLOUD];
    DFLY Dfly[MAXDFLY];
    EXPLODE Explode[MAXEXPLODE];
    //unsigned char *myfont;
    Font *TestFont;
    
void IntToStr(int i, TCHAR *scorestr)
{
  #if !defined(_WIN32_WCE) 
    _itoa(i,(char *)scorestr,10);  
  #else
    _itow(i,(wchar_t *)scorestr,10);  
  #endif
}    

unsigned char check_collision(int sx, int sy, int sxlength, int sylength,
                     int tx, int ty, int txlength, int tylength)
{
  unsigned char hits;
  hits=3;
  
  if (tx>sx)
  {
    if (tx<sx+sxlength) hits--;
  }
  else
  {
    if (sx<tx+txlength) hits--;
  }

  if (ty>sy)
  {
    if (ty<sy+sylength) hits--;
  }
  else
  {
    if (sy<ty+tylength) hits--;
  }

  return hits;
}


int LimitFrame(int option, int pfps)
{
    static int fps=0;
    static unsigned long counter;
    static unsigned long start;
    static unsigned long stop;
    static unsigned long scounter;
    static unsigned long sstart;
    static unsigned long sstop; 
   
    if (option==0)
    {
      start=GetTickCount();
      stop=0;
      counter=0;
      fps=pfps;
      //return fps;
    } 

    if (counter>30)
    {
      counter=scounter;
      start=sstart+(stop-sstop); 
    }

    for (;;)
    {
      stop = GetTickCount();
      if ((stop-start)>0) fps = (counter*1000) / (stop-start);
      if (fps < pfps) break;
    } 
    counter++;

    if (counter==15)
    {
      sstart=start;
      sstop=stop;
      scounter=counter;
    }
     
    return fps;
}



SnooblesGame::SnooblesGame(HINSTANCE hInstance)
{
    m_config.szWindowName     = _T("Snoobles - By Jason Chong.");
    m_config.orientation      = ORIENTATION_NORTH;
    m_config.splashScreenTime = 0;
    m_config.frameRate = 30;
    //m_config.desktopZoom = 2;
    Instance = hInstance;
}


void LoadFile(TCHAR fontfile[], unsigned char *font, int size)
{
  HANDLE f;
  DWORD br;
 // int CFGcnt;
  TCHAR path_buffer[_MAX_PATH];
/*  TCHAR drive[_MAX_DRIVE];
  TCHAR dir[_MAX_DIR];
  TCHAR fname[_MAX_FNAME];
  TCHAR ext[_MAX_EXT];
  TCHAR fontfilepath[_MAX_PATH];*/

  PocketPC::GetFullPathName(fontfile,path_buffer);
  //MessageBox(0,path_buffer,TEXT("none"),MB_OK);

  /*CFGcnt = GetModuleFileName(0,path_buffer,200);

  
  _tsplitpath( path_buffer, drive, dir, fname, ext );

  _tcscpy(fontfilepath,drive);
  _tcscat(fontfilepath,dir);
  _tcscat(fontfilepath,fontfile);
  //MessageBox(0,fontfilepath,"none",MB_OK);
  //PostQuitMessage(0);*/
  //f=CreateFile(fontfilepath,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
  f=CreateFile(path_buffer,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
  ReadFile(f,font,size,&br,NULL);
  CloseHandle(f);
}

bool SnooblesGame::GameInit()
{
    // Initialize random seed
    //myfont = new unsigned char[4096];
    //LoadFile(TEXT("fonts\\vgarom.fnt"),myfont,4096);
    srand( PocketPC::GetTickCount() );
    
    DisplayDevice* display = GetDisplay();
   

    ZeroMemory(&hssconfig, sizeof(HSSCONFIG));
 
    // set config.dwSoundFrequency = 0 to disable sound
    hssconfig.dwSoundFrequency = 22050;

    // if you set config.dwSoundBPS to 0 then the apps try to open Hekkus with
    // 16bit output, if it fails then it will use 8bit
    hssconfig.dwSoundBPS = 0;
    hssconfig.bSoundStereo = true;
    hssconfig.dwMODChannels = 1;
    hssconfig.dwSFXChannels = 16;

    if (hssconfig.dwSoundFrequency != 0)
        if (hssconfig.dwSoundBPS == 0)
        {
           if (m_sound.open(hssconfig.dwSoundFrequency, 16, hssconfig.bSoundStereo == TRUE,hssconfig.dwMODChannels, hssconfig.dwSFXChannels) == false)
              if (m_sound.open(hssconfig.dwSoundFrequency, 8, hssconfig.bSoundStereo == TRUE, hssconfig.dwMODChannels, hssconfig.dwSFXChannels) == false) {
                                        }
        
        }
        else {
            if (m_sound.open(hssconfig.dwSoundFrequency, hssconfig.dwSoundBPS, hssconfig.bSoundStereo == TRUE, hssconfig.dwMODChannels, hssconfig.dwSFXChannels) == false) {
        
                    }
        }

    // load ProTracker mod from resource
    m_module = new Module;
    m_module->load(TEXT("AUDIO\\heavybutcool.mod"));

    m_laser = new SoundFX;
    m_laser->load(TEXT("AUDIO\\laser.wav"));

    m_explode = new SoundFX;
    m_explode->load(TEXT("AUDIO\\explode.wav"));


    // set module looping flag to true
    m_module->loop(true);

    // play ProTracker mod
    m_sound.playMod(m_module);

    m_background = LoadImage( display, TEXT("BITMAPS\\bg.gif"));
    m_mainship = LoadImage( display, TEXT("BITMAPS\\mainship.gif"));
    m_mainship->SetColorMask( Color( 0, 0, 0) );
    m_dragonfly = LoadImage( display, TEXT("BITMAPS\\dfly.gif"));
    m_dragonfly->SetColorMask( Color( 0, 0, 0) );
    m_images[0] = LoadImage( display, TEXT("BITMAPS\\laser.gif"));
    m_images[0]->SetColorMask( Color( 0, 0, 0) );
    m_images[1] = LoadImage( display, TEXT("BITMAPS\\cloud.gif"));
    m_images[1]->SetColorMask( Color( 0, 0, 0) );
    m_images[2] = LoadImage( display, TEXT("BITMAPS\\explode.gif"));
    m_images[2]->SetColorMask( Color( 0, 0, 0) );

    m_font = LoadImage( display, TEXT("BITMAPS\\menufont.gif"));
    m_font->SetColorMask(Color(255,0,255));  // load font surface
    
    TestFont = new Font(m_font); // create font data
    

    SX=60;
    SY=300;
    sframe=7;

    b_up=false;
    b_down=false;
    b_left=false;
    b_right=false;
    b_fire=false;

    for (int i=0; i<MAXLASER; i++) Laser[i].Active=false;
    for (i=0; i<MAXCLOUD; i++) Cloud[i].Active=false;
    for (i=0; i<MAXDFLY; i++) Dfly[i].Active=false;
    for (i=0; i<MAXEXPLODE; i++) Explode[i].Active=false;

    LimitFrame(0,30);
    return true;
}



void SnooblesGame::GameEnd()
{ 
 
   m_sound.close();
   delete TestFont; // delete font data
   delete m_font; // delete font surface
   delete m_explode;
   delete m_laser;
   delete m_module;
   delete m_images[2];
   delete m_images[1];
   delete m_images[0];
   delete m_dragonfly;
   delete m_mainship;
   delete m_background;
   //delete myfont;

}

void SnooblesGame::Scroller(DisplayDevice *display)
{
    static int y = -320;
    display->Blit(0,y,m_background);
    display->Blit(0,y+320,m_background);
    y++;
    if (y>=0) y = -320;
}

void SnooblesGame::MainShip(DisplayDevice *display)
{
   if (SX<=-30) SX = -30;
   if (SY<=0) SY = 0;
   if (SX>=(240-70)) SX = 240-70;
   if (SY>=(320-60)) SY = 320-60;
   display->Blit(SX,SY,m_mainship,&Rect(0,(75*sframe),100,(75*sframe)+75)); 
}

void SnooblesGame::DrawFire(DisplayDevice *display)
{
   for (int i=0; i<MAXLASER; i++)
   {
     if (Laser[i].Active)
     {
       Laser[i].Y-=10;
       if (Laser[i].Y<=-21) Laser[i].Active = 0;
       display->Blit(Laser[i].X, Laser[i].Y, m_images[0]); 
     }
   }
}

void SnooblesGame::DrawCloud(DisplayDevice *display)
{
   for (int i=0; i<MAXCLOUD; i++)
   {
     if (Cloud[i].Active)
     {
       Cloud[i].Y += Cloud[i].Step;
       if (Cloud[i].Y>=320) Cloud[i].Active = 0;
       display->SetBlending(Cloud[i].Alpha);
       display->Blit(Cloud[i].X, Cloud[i].Y, m_images[1]); 
       display->SetBlending(255);
     }
   }
}


void SnooblesGame::DrawDfly(DisplayDevice *display)
{
   for (int i=0; i<MAXDFLY; i++)
   {
     if (Dfly[i].Active)
     {
       Dfly[i].Y += Dfly[i].Step;
       if (Dfly[i].Y>=320) Dfly[i].Active = 0;
       display->Blit(Dfly[i].X, Dfly[i].Y, m_dragonfly, &Rect(0,(80*Dfly[i].Frame),60,(80*Dfly[i].Frame)+80) ); 
       Dfly[i].Frame++;
       if (Dfly[i].Frame==15) Dfly[i].Frame=0;
     }
   }
}


void SnooblesGame::DrawExp(DisplayDevice *display)
{
   for (int i=0; i<MAXEXPLODE; i++)
   {
     if (Explode[i].Active)
     {
       if (Explode[i].Frame>=13) Explode[i].Active = 0;
       else
       {
         display->SetBlending(Explode[i].Alpha);
         display->Blit(Explode[i].X, Explode[i].Y, m_images[2], &Rect(0,(105*Explode[i].Frame),105,(105*Explode[i].Frame)+105) ); 
         display->SetBlending(255);
         Explode[i].Alpha-=15;
         Explode[i].Frame++;
       }
     }
   }
}


void SnooblesGame::InitFire(int X, int Y)
{
  for (int i=0; i<MAXLASER; i++)
  {
    if (!Laser[i].Active) 
    {
      Laser[i].Active=true;
      Laser[i].X=X;
      Laser[i].Y=Y;
      break;
    }
  }
}

void SnooblesGame::InitCloud(int X, int Y)
{
  for (int i=0; i<MAXCLOUD; i++)
  {
    if (!Cloud[i].Active) 
    {
      Cloud[i].Active=true;
      Cloud[i].X=X;
      Cloud[i].Y=Y;
      Cloud[i].Alpha=64+ (rand() %128);
      Cloud[i].Step=2;
      break;
    }
  }
}

void SnooblesGame::InitDfly(int X, int Y)
{
  for (int i=0; i<MAXDFLY; i++)
  {
    if (!Dfly[i].Active) 
    {
      Dfly[i].Active=true;
      Dfly[i].X=X;
      Dfly[i].Y=Y;
      Dfly[i].Frame=rand() % 10;
      Dfly[i].Step=3;
      break;
    }
  }
}

void SnooblesGame::InitExp(int X, int Y)
{
  for (int i=0; i<MAXEXPLODE; i++)
  {
    if (!Explode[i].Active) 
    {
      Explode[i].Active=true;
      Explode[i].X=X;
      Explode[i].Y=Y;
      Explode[i].Alpha=255;
      Explode[i].Frame=0;
      break;
    }
  }
}

void SnooblesGame::DoCollision()
{
  int res;
  int i,j;
  for (i=0; i<MAXLASER; i++)
  {
    if (Laser[i].Active) 
    {
      for (j=0; j<MAXDFLY; j++)
      {
        if (Dfly[j].Active)
        {
          res=check_collision(Laser[i].X, Laser[i].Y, 7, 21, Dfly[j].X+20, Dfly[j].Y, 20, 50);
          if (res==1) {
            Dfly[j].Active=false;
            Laser[i].Active=false;
            InitExp(Dfly[j].X-20,Dfly[j].Y+5);
            m_sound.playSFX(m_explode);
            break;
          }
        }
      }
    }
  }
}


void SnooblesGame::GameLoop()
{
    DisplayDevice* display = GetDisplay();
    TCHAR fpsstr[30];
    static int counter=0;
    int fps;

    //display->Clear(Color(0,0,rand() % 255));

    if (b_up) SY-=4; 
    if (b_down) SY+=4;
    if (b_left) 
    {
       SX-=3;
       if (sframe > 0) sframe--;
    }
    if (b_right) 
    {
       SX+=3;
       if (sframe < 14) sframe++;
    }
    if (!b_left && !b_right) 
    {
      if (sframe != 7)
      {
        if (sframe>7) sframe--;
          else
        if (sframe<7) sframe++;
      }
    }
//    for (int i=0; i<10; i++) display->DrawCircle(rand() % 240 , rand() % 320, rand() % 100, Color(0,255,0) );
    //display->Blit(20 + rand() % 3, 20 + rand() % 3, m_images[0], &Rect(0,0,100,100));

        

    if ((b_fire) && ((counter % 4)==1))
    {
      InitFire(SX+32,SY);
      InitFire(SX+58,SY);
      m_sound.playSFX(m_laser);
    }
    
    if ((counter % 50)==1) InitCloud(-40 + (rand() % 200),-100);

    if ((counter % 15)==1) InitDfly(0 + (rand() % 180),-100);

    Scroller(display);
    DrawCloud(display);
    DrawDfly(display);
    MainShip(display);
    DrawFire(display);
    DrawExp(display);

    DoCollision(); 
    counter++;
    
    fps = LimitFrame(1,30);

    if (fps < 25) 
    {
      LimitFrame(0,30);
      //display->DrawVGAText(myfont, TEXT("LimitFrame Reset!"),  DVT_NONE, 0,0,  Color(255, 255, 255));
      TestFont->DisplayText(display,0,0, TEXT("LimitFrame Reset!"));
    }
    else
    {
      IntToStr(fps,fpsstr);
      //display->DrawVGAText(myfont, fpsstr,  DVT_NONE, 0,0,  Color(255, 255, 255));
      TestFont->DisplayText(display,0,0, fpsstr);
	  TestFont->DisplayText(display,40,0, TEXT("Testing 1.2.3!"));
    }
    //if (counter>60) Sleep(rand() % 50);
    display->Update();   
}

void SnooblesGame::ButtonDown( int button )
{
  const InputDevice::KeyList& keys = GetInput()->GetKeyList();  
  if (button == keys.vkUp) b_up = true;
  if (button == keys.vkDown) b_down = true;
  if (button == keys.vkLeft) b_left = true;
  if (button == keys.vkRight) b_right = true;
  if (button == keys.vkA) b_fire = true;
}

void SnooblesGame::ButtonUp( int button )
{
  const InputDevice::KeyList& keys = GetInput()->GetKeyList();  
  if (button == keys.vkUp) b_up = false;
  if (button == keys.vkDown) b_down = false;
  if (button == keys.vkLeft) b_left = false;
  if (button == keys.vkRight) b_right = false;
  if (button == keys.vkA) b_fire = false;
}

void SnooblesGame::GameResume()
{
}

void SnooblesGame::StylusDown( Point stylus )
{
  Shutdown();
}



void SnooblesGame::StylusUp( Point stylus )
{
}



void SnooblesGame::StylusMove( Point stylus )
{
}


int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE, LPTSTR, int )
{
    _Module.Init( 0, hInstance );

    SnooblesGame Snoob(hInstance);

    Snoob.Run();

    return 0;
}

